Subject: Re: git pull is slow

From: Stephan Hennig <[email-masked]>
Date: Sun, 13 Jul 2008 11:01:29 +0200

Johannes Schindelin schrieb:

> I suspected that you run out of space for the cache holding some 
> reconstructed blobs (to prevent reconstructing all of them from scratch).
> 
> [...]
> 
> Okay, "valgrind --tool=massif" to the rescue:
> 
> -- snip --
> MB
> 555.9^                                                            ,  #
> |                                                                 @..#
> ~
> | . :::: ::: ::::: @:: : : :: : :: :@ :@: :@@::@:: :::: @: : @@: :@::# ::
> 0----------------------------------------------------------------------->Gi
>                                                                    32.83
> -- snap --
> 
> [...]
> 
> Now, I do not know the internals of index-pack enough to know if there is 
> a way to cut the memory usage (by throwing out earlier reconstructed 
> blobs, for example, and reconstructing them _again_ if need be), so I 
> Cc:ed Nico and hand the problem off to him.
> 
> I expect this to touch the resolve_delta() function of index-pack.c in a 
> major way, though.

Thank you for the analysis!  As a workaround, I think about splitting
the file.  Can you suggest a proper file size?

Best regards,
Stephan Hennig